;-mem.asm--------------------------------------------------------------------
;          x86 - Dos & Win32 - Assembly Language Programming                ;
;                                                                           ;
; Written by: John A Lyons                                                  ;
; Email     : sysop@megablast.8k.com                                        ;
; Page      : http://www.asmsource.8k.com/                                  ;
; Compiler  : Masm32 v6.13 Microsoft Macro Assembler                        ;
; Date      : 12-Feb-2001                                                   ;
; Purpose   : Program the displays information about memory. User a timer   ;
;             interrupt to update, and a dialog box as the main window. Also;
;             Changes the window text so that load is updated in taskbar    ;
;                                                                           ;
;             Thanks to 'RAZOR'X and his program mem-info                   ;
;                                                                           ;
;----------------------------------------------------------------------------
      .686
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive
.mmx
;.p2
      include \MASM32\INCLUDE\windows.inc
      include \MASM32\INCLUDE\masm32.inc
      include \MASM32\INCLUDE\gdi32.inc
      include \MASM32\INCLUDE\user32.inc
      include \MASM32\INCLUDE\kernel32.inc
      include \MASM32\INCLUDE\Comctl32.inc
      include \MASM32\INCLUDE\comdlg32.inc
      include \MASM32\INCLUDE\shell32.inc
      include \masm32\include\shlwapi.inc
      include \MASM32\include\oleaut32.inc


      includelib \MASM32\LIB\gdi32.lib
      includelib \MASM32\LIB\user32.lib
      includelib \MASM32\LIB\kernel32.lib
      includelib \MASM32\LIB\Comctl32.lib
      includelib \MASM32\LIB\comdlg32.lib
      includelib \MASM32\LIB\shell32.lib
      includelib \masm32\lib\shlwapi.lib
      includelib \MASM32\LIB\oleaut32.lib

        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>



; procedures declared later
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
update proto :DWORD
DlgProc proto hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM



.data

hArial_Bold_12          DWORD 0
sz_Arial    DB  "Arial",0

num1  DWORD 0
num2  DWORD 0
num3  DWORD 0
num4  DWORD 0

ClassName       db "DLGCLASS",0
MenuName        db "MyMenu",0
DlgName         db "MainDialog",0
AppName         db "Memory Info",0
AbtName         db "AboutDialog",0

PRINT_lu            db "%lu",0
PRINT_2D            db "%2d",0

hInstance       HINSTANCE ?
CommandLine     LPSTR ?
mem1            db "Load %"

buff0            db 325 dup(?)
buff00           db 325 dup(?)
buff1            db 325 dup(?)
buff2            db 325 dup(?)
buff3            db 325 dup(?)


menuhand        DWORD ?
count           DWORD ?

;about data
hwnd            HWND ?
hover           BOOL ?

hFinger         dd ?
orgStatic       dd ?
hwndDlg         dd ?
szOpen          db "open",0

.const
;buttons
IDC_EXIT        equ 3002
;timer
ID_TIMER        equ 400
;menu
IDM_FAST        equ 32000
IDM_SLOW        equ 32001
IDM_EXIT        equ 32003
IDM_ABOUT       equ 32002

;dialog
IDD_TPYHS       equ 501
IDD_APYHS       equ 502
IDD_APAGE       equ 504
IDD_TPAGE       equ 503
IDD_AVIRT       equ 505
IDD_TVIRT       equ 506
IDD_LOAD        equ 507

IDI_ICON1       equ 5

IDC_URL         equ 9
IDI_CUR1        equ 101

.data?
; ............................................................
lf                              LOGFONTA                <?>

mst         MEMORYSTATUS           <?>

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hDlg:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,DLGWINDOWEXTRA
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon, hInstance, IDI_ICON1
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateDialogParam,hInstance,ADDR DlgName,NULL,NULL,NULL
	mov   hDlg,eax

	INVOKE ShowWindow, hDlg,SW_SHOWNORMAL
	INVOKE UpdateWindow, hDlg


;  .....................................  Arial Bold Wide 12 pt
	    mov esi, offset sz_Arial
	    mov edi, offset lf.lfFaceName
	    mov ecx, Sizeof sz_Arial
	    rep movsb

	    mov     lf.lfHeight, -17
	    mov     lf.lfWidth, -10
	    mov     lf.lfWeight, 900

PUSH    offset lf
CALL    CreateFontIndirectA
mov     hArial_Bold_12, eax




	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke IsDialogMessage, hDlg, ADDR msg
                .if eax==FALSE
                        INVOKE TranslateMessage, ADDR msg
                        INVOKE DispatchMessage, ADDR msg
                .endif
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        .if uMsg==WM_GETMINMAXINFO ; 24

                invoke GetMenu,hWnd
                mov menuhand,eax
                invoke SetTimer, hWnd, ID_TIMER, 2000, 0

                invoke DefWindowProc,hWnd,uMsg,wParam,lParam

                ret
        .ELSEIF uMsg==WM_ACTIVATE

                invoke update,hWnd

                ret

	.ELSEIF uMsg==WM_DESTROY
                invoke KillTimer,hWnd,ID_TIMER
		invoke PostQuitMessage,NULL
                ret

        .ELSEIF uMsg==WM_TIMER

                invoke update,hWnd
                invoke SetWindowText,hWnd,ADDR mem1

                ret
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF lParam==0
                         .IF ax==IDM_EXIT
                                invoke DestroyWindow,hWnd
                                ret
                         .ELSEIF ax==IDM_SLOW

                                invoke CheckMenuItem,menuhand,IDM_SLOW,MF_CHECKED
                                invoke CheckMenuItem,menuhand,IDM_FAST,MF_UNCHECKED
                                invoke KillTimer,hWnd,ID_TIMER
                                invoke SetTimer, hWnd, ID_TIMER, 60000, 0

                         .ELSEIF ax==IDM_FAST

                                invoke CheckMenuItem,menuhand,IDM_SLOW,MF_UNCHECKED
                                invoke CheckMenuItem,menuhand,IDM_FAST,MF_CHECKED
                                invoke KillTimer,hWnd,ID_TIMER
                                invoke SetTimer, hWnd, ID_TIMER, 5000, 0
                        .ELSEIF ax==IDM_ABOUT

                                invoke CreateDialogParam,hInstance, addr AbtName,hWnd,OFFSET DlgProc,NULL
                                mov hwndDlg,eax
                         .ENDIF
		.ELSE
                        .IF ax==IDC_EXIT
					invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0
                                        ret
			.ENDIF
		.ENDIF
	.ELSE

		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
update proc hWnd:HWND

invoke GlobalMemoryStatus,ADDR mst


mov eax,mst.dwMemoryLoad
push eax
push offset PRINT_lu
push offset buff00
call wsprintfA
add esp,0ch

invoke SendDlgItemMessage, hWnd, IDD_LOAD, WM_SETTEXT, 0,ADDR buff00


mov eax,mst.dwAvailPhys
push eax
push offset PRINT_lu
push offset buff0
call wsprintfA
add esp,0ch

invoke SendDlgItemMessage, hWnd, IDD_APYHS, WM_SETTEXT, 0,ADDR buff0

push offset buff1
push offset buff0
CALL szCopy


push offset buff2
push offset buff1
CALL szCopy

    mov eax, offset buff2
    mov ebx, offset buff1
    sub eax, ebx
        mov num1, eax

push offset PRINT_2D
push offset num1
call wsprintfA

invoke SendDlgItemMessage, hWnd, IDD_TPYHS, WM_SETTEXT, 0,ADDR num1

;invoke MessageBox,0,ADDR buff1,0,0

;invoke MessageBox,0,ADDR num1,0,0

;...............................clean
;  xor eax,eax
;  mov edi, offset buff2
;  mov ecx, 25
;  rep stosb



           ret
update endp

;----------------------------------------------------ABOUT procedure
HyperLinkWndProc PROC uses ebx, hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL tmpFont  :LOGFONT 
LOCAL rect:RECT
LOCAL pt:POINT


    .IF uMsg==WM_NCHITTEST
        mov eax, 1
            ret


    .ELSEIF uMsg==WM_MOUSEMOVE
        invoke GetParent,hWnd
        push ebx
        mov ebx,eax
        invoke GetActiveWindow
            .if eax == ebx
                invoke GetCursorPos,addr pt
                invoke GetWindowRect,hWnd,addr rect
                invoke PtInRect,addr rect,pt.x,pt.y
       .if eax
                invoke GetCapture
                .if !eax
                    invoke SetCapture,hWnd
                    mov hover,TRUE
                    invoke InvalidateRect,hWnd,FALSE,FALSE
                    invoke SetCursor,hFinger

                .endif
       .else
                invoke GetCapture

                .if eax
                    invoke ReleaseCapture
                    mov hover,FALSE
                    invoke InvalidateRect,hWnd,FALSE,FALSE
                .endif

       .endif
       .endif
       pop ebx
       xor eax,eax
       ret

    .ELSEIF uMsg==WM_LBUTTONDOWN

            invoke GetWindowText,hWnd,offset buff0,sizeof buff0       ;change this for using a preset url
            invoke ShellExecute, NULL, offset szOpen, offset buff0, NULL, NULL, SW_MAXIMIZE ;change this to represent your preset url
            mov hover,FALSE
            invoke InvalidateRect,hWnd,FALSE,FALSE

            xor eax,eax

            ret
    .ENDIF

    invoke CallWindowProc, orgStatic, hWnd, uMsg, wParam, lParam
    ret

HyperLinkWndProc endp
DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
        .if iMsg==WM_INITDIALOG
                invoke GetDlgItem,hWnd,IDC_EXIT
                invoke SetFocus,eax

                invoke GetDlgItem, hWnd, IDC_URL

                invoke SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
                mov orgStatic,eax

                invoke LoadCursor,hInstance,IDI_CUR1
                mov hFinger,eax


                xor eax,eax
                ret

        .elseif iMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
		mov hwndDlg,0
        .elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
                ;.if dx==BN_CLICKED
			.if eax==IDC_EXIT
				invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
                                invoke EndDialog,hWnd,NULL
                                mov hwndDlg,0
			.endif
                ;.endif
        .else
		mov eax,FALSE
		ret
        .endif
        mov  eax,TRUE
        ret
DlgProc endp


; ###############################################

  align 4

szCopy proc src:DWORD,dst:DWORD

xor edx, edx    ; (dh/dl)

            mov esi, src   ;  put address into the source index
            mov edi, dst   ;  put address into the destination index

    @@:
        mov dl, [esi]           ;  copy byte at address in esi to dl
        inc esi                 ;  increment address in esi
        mov [edi], dl           ;  copy byte in dl to address in edi

        inc edi                 ;  increment address in edi
        cmp dl, 0               ;  see if its an ascii zero
jne @B                          ;  jump back and read next byte if no

    ret

szCopy ENDP
; ###############################################


end start




